%global tarball xf86-video-amdgpu
%global moduledir %(pkg-config xorg-server --variable=moduledir )
%global driverdir %{moduledir}/drivers
#global gitdate 20160929
%global gitversion 97d7386c

%if 0%{?gitdate}
%global gver .%{gitdate}git%{gitversion}
%endif

Name: x11-driver-video-amdgpu
Version: 23.0.0
Release: %mkrel 5%{?gver}
Summary: X.org driver for AMD
Group: System/X11
URL: https://xorg.freedesktop.org
License: MIT
%if 0%{?gitdate}
Source0: %{tarball}-%{gitdate}.tar.xz
%else
Source0: https://xorg.freedesktop.org/releases/individual/driver/xf86-video-amdgpu-%{version}.tar.xz
%endif

# upstream fixes (see https://gitlab.freedesktop.org/xorg/driver/xf86-video-amdgpu)
#
Patch0001:     0001-Fix-segfault-on-dock-suspend-unplug-resume.patch
Patch0002:     0002-Free-output_ids.patch
Patch0003:     0003-Enable-TearFree-if-it-s-set-to-auto-and-VariableRefr.patch
Patch0004:     0004-Handling-of-color-management-properties.patch
Patch0007:     0007-drop-compat-with-ancient-xserver-versions.patch
Patch0008:     0008-dont-check-for-HAS_DIRTYTRACKING_ROTATION-it-s-alway.patch
Patch0009:     0009-dont-use-obsolete-pict_f_transform-alias-anymore.patch
Patch0012:     0012-Check-GFX12-swizzle-mode-correctly.patch
Patch0013:     0013-use-XNFalloc-instead-of-xnfalloc.patch
Patch0014:     0014-use-XNFcallocarray-instead-of-xnfcalloc-macro.patch
Patch0015:     0015-Use-GBM_BO_USE_FRONT_RENDERING-on-front_buffer-alloc.patch
Patch0016:     0016-Fixed-AMDGPUOptions_KMS-for-align-structures-64bit.patch
Patch0017:     0017-use-dixDestroyPixmap-instead-of-direct-driver-call.patch

BuildRequires: pkgconfig(applewmproto) >= 1.0.0
BuildRequires: pkgconfig(dri)
BuildRequires: pkgconfig(gbm)
BuildRequires: pkgconfig(libdrm) >= 2.4.121
BuildRequires: pkgconfig(xorg-server) >= 1.19.0
BuildRequires: pkgconfig(libudev)
BuildRequires: x11-util-macros >= 1.0.1
# force new gcc
BuildRequires: gcc >= 12.0.1-0.20220227.2
BuildRequires: binutils >= 1:2.38-4

Requires: x11-server-common %(xserver-sdk-abi-requires videodrv)

Recommends: radeon-firmware

%description
x11-driver-video-amdgpu is the X.org driver for AMD Southern Islands
and later.

%prep
%setup -q -n %{tarball}-%{?gitdate:%{gitdate}}%{?!gitdate:%{version}}
%autopatch -p1

%build
#autoreconf -fiv
%configure --enable-glamor
%make_build

%install
%make_install
find %{buildroot} -name '*.la' -exec rm -f {} ';'

%files
%{driverdir}/amdgpu_drv.so
%{_datadir}/X11/xorg.conf.d/10-amdgpu.conf
%{_mandir}/man4/amdgpu.4*


%changelog
* Sat May 31 2025 ghibo <ghibo> 23.0.0-5.mga10
+ Revision: 2187490
- Merge more patches from git upstream.
- Update BRs.

* Sat Oct 21 2023 ghibo <ghibo> 23.0.0-2.mga10
+ Revision: 2000025
- Merge patches from git upstream (fix segfault under certain circumstances)

* Wed Feb 22 2023 tmb <tmb> 23.0.0-1.mga9
+ Revision: 1944945
- update to 23.0.0
  * drop merged patches

* Fri Feb 10 2023 ghibo <ghibo> 22.0.0-3.mga9
+ Revision: 1939966
- Merge Patch1-4 from deb/git upstream to fix 1 FPS frame rate after LID is resumed.
- Merge Patch5 from deb/git upstream to fix slow frame rate with AMD GPU output in reverse prime mode.
- Merge Patch7 from opensuse/git upstream to fix invisible mouse pointer on Radeon 7900XTX.
- Merge Patch8 from git upstream to prefer crtc of primary output for sync when screen has to crtcs with the same coverage.
- Merge Patch9 from git upstream to fix hotplug driver name.

* Thu Mar 03 2022 tmb <tmb> 22.0.0-2.mga9
+ Revision: 1788167
- rebuild with gcc 12

* Thu Feb 24 2022 tmb <tmb> 22.0.0-1.mga9
+ Revision: 1784158
- update to 22.0.0

* Sat Oct 02 2021 tmb <tmb> 21.0.0-2.mga9
+ Revision: 1748536
- glamor: Set AMDGPU_CREATE_PIXMAP_SCANOUT on DRI2 and shared pixmaps

* Fri Jul 30 2021 tmb <tmb> 21.0.0-1.mga9
+ Revision: 1738222
- update to 21.0.0

* Mon Jun 14 2021 tv <tv> 19.1.0-8.mga9
+ Revision: 1730700
- Remove dri.h includes and use xf86drm.h

* Sun Feb 07 2021 tmb <tmb> 19.1.0-7.mga8
+ Revision: 1675027
- update summary and description

* Tue Dec 15 2020 tmb <tmb> 19.1.0-6.mga8
+ Revision: 1657916
- Fix return value check of drmIoctl()

* Tue Dec 15 2020 tmb <tmb> 19.1.0-5.mga8
+ Revision: 1657912
- Handle NULL fb_ptr in pixmap_get_fb

* Wed May 13 2020 tv <tv> 19.1.0-4.mga8
+ Revision: 1583578
- Fix link error with gcc 10
+ danf <danf>
- Switch URLs from http: to https:
+ wally <wally>
- replace deprecated %%configure2_5x

* Sat Oct 12 2019 tv <tv> 19.1.0-3.mga8
+ Revision: 1452377
- new release

* Sat May 18 2019 tmb <tmb> 19.0.1-3.mga7
+ Revision: 1398349
- dri3: Always flush glamor before sharing pixmap storage with clients

* Tue May 07 2019 tmb <tmb> 19.0.1-2.mga7
+ Revision: 1396638
- Retry get_fb_ptr in get_fb (fdo #110417)

* Wed Mar 20 2019 tv <tv> 19.0.1-1.mga7
+ Revision: 1379143
- new release

* Wed Mar 06 2019 tmb <tmb> 19.0.0-1.mga7
+ Revision: 1372058
- update to 19.0.0

* Sat Sep 15 2018 tv <tv> 18.1.0-1.mga7
+ Revision: 1259011
- new release

* Fri Mar 16 2018 tv <tv> 18.0.1-1.mga7
+ Revision: 1209908
- new release

* Sat Mar 10 2018 tv <tv> 18.0.0-2.mga7
+ Revision: 1207933
- rebuild for xserver 1.20 RC1

* Fri Mar 09 2018 tv <tv> 18.0.0-1.mga7
+ Revision: 1207527
- new release

* Fri Sep 08 2017 tv <tv> 1.4.0-1.mga7
+ Revision: 1151857
- new release

* Sat Sep 02 2017 tmb <tmb> 1.3.0-2.mga7
+ Revision: 1150686
- rebuild with new gcc/binutils

* Fri Mar 17 2017 tv <tv> 1.3.0-1.mga6
+ Revision: 1093270
- BR libudev-devel
- new release

* Fri Nov 18 2016 tv <tv> 1.2.0-1.mga6
+ Revision: 1068174
- new release

* Thu Nov 17 2016 tv <tv> 1.1.2-3.20160929git97d7386c.mga6
+ Revision: 1067684
- use a git snapshot (fixes for use with xserver-1.19)
- rebuild for xserver 1.19

* Wed Oct 05 2016 tv <tv> 1.1.2-1.mga6
+ Revision: 1058920
- remove useless sed
- use %%autosetup
- use %%global instead of %%define
- remove .la files
- new release

* Thu Sep 15 2016 tv <tv> 1.1.1-1.mga6
+ Revision: 1053119
- new version

* Fri Jul 22 2016 tmb <tmb> 1.1.0-4.mga6
+ Revision: 1043199
- DRI2: Add interpolated_vblanks in amdgpu_dri2_get_crtc_msc

* Thu Jul 21 2016 tmb <tmb> 1.1.0-3.mga6
+ Revision: 1043026
- sync in more upstream fixes

* Tue Jul 05 2016 tmb <tmb> 1.1.0-2.mga6
+ Revision: 1038936
- sync in fixes from upstream git

* Fri Apr 08 2016 tv <tv> 1.1.0-0.mga6
+ Revision: 999349
- new release

* Wed Feb 24 2016 tv <tv> 1.0.1-0.mga6
+ Revision: 978598
- new release

* Mon Nov 23 2015 tv <tv> 1.0.0-0.mga6
+ Revision: 905097
- new release

* Wed Nov 11 2015 tv <tv> 0.1-0.20151104git92e7c93.mga6
+ Revision: 902255
- BR pkgconfig(gbm)
- imported package x11-driver-video-amdgpu

